--
-- PostgreSQL database dump
--

-- Dumped from database version 14.3
-- Dumped by pg_dump version 14.3

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: doctrine_migration_versions; Type: TABLE; Schema: public; Owner: user
--

CREATE TABLE public.doctrine_migration_versions (
    version character varying(191) NOT NULL,
    executed_at timestamp(0) without time zone DEFAULT NULL::timestamp without time zone,
    execution_time integer
);


ALTER TABLE public.doctrine_migration_versions OWNER TO "user";

--
-- Name: menu; Type: TABLE; Schema: public; Owner: user
--

CREATE TABLE public.menu (
    id integer NOT NULL,
    name character varying(255) NOT NULL,
    slug character varying(255) NOT NULL,
    parent_id integer,
    content text,
    is_visible boolean NOT NULL
);


ALTER TABLE public.menu OWNER TO "user";

--
-- Name: menu_id_seq; Type: SEQUENCE; Schema: public; Owner: user
--

CREATE SEQUENCE public.menu_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.menu_id_seq OWNER TO "user";

--
-- Data for Name: doctrine_migration_versions; Type: TABLE DATA; Schema: public; Owner: user
--

COPY public.doctrine_migration_versions (version, executed_at, execution_time) FROM stdin;
DoctrineMigrations\\Version20220530132524	2022-06-16 12:19:00	120
DoctrineMigrations\\Version20220530133141	2022-06-16 12:19:01	4
DoctrineMigrations\\Version20220530164457	2022-06-16 12:19:01	34
\.


--
-- Data for Name: menu; Type: TABLE DATA; Schema: public; Owner: user
--

COPY public.menu (id, name, slug, parent_id, content, is_visible) FROM stdin;
55	HTTP	http	\N	<div><strong>HTTP (HyperText Transfer Protocol):</strong></div><div>Протокол передачи гипертекста—протокол прикладного уровня передачи данных, изначально — в виде гипертекстовых документов в формате HTML, в настоящее время используется для передачи произвольных данных.<br><br><strong>HTTPS (HyperText Transfer Protocol Secure):</strong></div><div>Расширение протокола HTTPдля поддержки шифрованияв целях повышения безопасности.&nbsp;<br>Данные в протоколе HTTPS передаются поверх криптографических протоколов&nbsp;<br>TLS или устаревшего в 2015 году SSL<br><br></div><div><a href="https://ru.wikipedia.org/wiki/SOAP"><strong><em>SOAP</em></strong></a> <strong><em>— </em></strong>текстовый протокол на базе HTTP</div>	t
56	Статусы	statusy	55	<div><strong><em>Статусы:</em></strong>&nbsp;</div><ul><li>Информационные 100-199 (пример102 "в обработке")&nbsp;</li><li>Успешные 200-299(пример 204 "нет содержимого", но заголовки присылаются)&nbsp;</li><li>Перенаправления 300-399(303 "Просмотр других ресурсов")</li><li>&nbsp;Клиентские ошибки 400-499(400 "Плохой запрос")&nbsp;</li><li>Серверные ошибки 500-599(500 "Внутренняя ошибка сервера")</li></ul>	t
59	Методы	metody	55	<div><strong><em>Методы HTTP запроса:</em></strong></div><ul><li><strong>GET</strong>- получение ресурса</li><li><strong>HEAD</strong> - запрашивает ресурс так же, как и метод GET, но без тела ответа.</li><li><strong>POST</strong>- создание ресурса</li><li><strong>PUT</strong>- обновление ресурса</li><li><strong>PATCH</strong>- используется для частичного изменения ресурса</li><li><strong>DELETE</strong>- удаление ресурса</li><li><strong>CONNECT</strong>- устанавливает "туннель" к серверу, определённому по ресурсу.</li><li><strong>OPTIONS</strong>- используется для описания параметров соединения с ресурсом.</li><li><strong>TRACE</strong>- выполняет вызов возвращаемого тестового сообщения с ресурса</li></ul>	t
58	REST	rest	\N	<div><strong>REST (Representational State Transfer):</strong><br>Передача состояния представления, другими словами, REST— это набор правил того, как программисту организовать написание кода серверного приложения, чтобы все системы легко обменивались данными и приложение можно было масштабировать</div>	t
60	API	api	58	<div><strong><em>API (A</em></strong><em>pplication </em><strong><em>P</em></strong><em>rogramming </em><strong><em>I</em></strong><em>nterface</em><strong><em>):</em></strong><br>Программный интерфейс приложения- описание способов (набор классов, процедур, функций, структур или констант), которыми одна компьютерная программа может взаимодействовать с другой программой.<br><br></div>	t
57	SYMFONY	symfony	\N	<div><br><br></div>	t
61	REST API	rest-api	58	<div><strong><em>REST API:</em></strong><br>Это когда серверное приложение дает доступ к своим данным клиентскому приложению по определенному URL. Далее разберем подробнее, начиная с базовых понятий.<br><br><br></div>	t
64	Область видимости	oblast-vidimosti	63	<div><a href="https://www.php.net/manual/ru/language.variables.scope.php">Область видимости переменной</a></div><div>Область видимости переменной - это контекст, в котором эта переменная определена. В большинстве случаев все переменные PHP имеют только одну область видимости. Эта единая область видимости охватывает также включаемые (include) и требуемые (require) файлы.</div>	t
65	Переменные переменных	peremennye-peremennykh	63	<div><a href="https://www.php.net/manual/ru/language.variables.variable.php">Переменные переменных</a></div><div>Иногда бывает удобно иметь переменными имена переменных. То есть, имя переменной, которое может быть определено и изменено динамически.</div><div>Переменная переменной берет значение переменной и рассматривает его как имя переменной.</div><div>$$a='world';</div>	t
66	Переменные извне PHP	peremennye-izvne-php	63	<div><a href="https://www.php.net/manual/ru/language.variables.external.php">Переменные извне PHP</a><br>Когда происходит отправка данных формы PHP-скрипту, информация из этой формы автоматически становится доступной ему. Существует несколько способов получения этой информации<br>Есть только два способа получить доступ к данным из форм HTML.<br><br>\techo $_POST['username'];<br><br>\techo $_REQUEST['username'];</div><div><br></div>	t
68	Предопределенные костанты	predopredelennye-kostanty	67	<div><a href="https://www.php.net/manual/ru/reserved.constants.php"><em>Предопределенные костанты</em></a><em><br></em><br></div><div>Эти константы объявляются ядром PHP</div><div><br></div>	t
69	Магические константы	magicheskie-konstanty	67	<div><a href="https://www.php.net/manual/ru/language.constants.magic.php">Магические константы</a><br>Есть девять магических констант, которые меняют своё значение в зависимости от контекста, в котором они используются. Например, значение __LINE__ зависит от строки в скрипте, на которой эта константа указана. Все магические константы разрешаются во время компиляции, в отличие от обычных констант, которые разрешаются во время выполнения</div><div><br></div>	t
67	Константы	konstanty	62	<div><strong><em>Различия между константами и переменными:</em></strong></div><div>У констант нет приставки в виде знака доллара ($);</div><div>Константы могут быть определены и доступны в любом месте без учёта области видимости;</div><div>Константы не могут быть переопределены или удалены после первоначального объявления;&nbsp;</div><div>Константы могут иметь только скалярные значения или массивы.<br>До PHP 8.0.0 константы, определённые с помощью функции <a href="https://www.php.net/manual/ru/function.define.php">define()</a>, могли быть нечувствительными к регистру<br>Константа может быть определена с помощью ключевого слова constили с помощью функции <a href="https://www.php.net/manual/ru/function.define.php">define()</a>. В то время как <a href="https://www.php.net/manual/ru/function.define.php">define()</a>позволяет задать константу через выражение, конструкция constограничена как описано в следующем параграфе. После того, как константа определена, её значение не может быть изменено или аннулировано.</div><div>При использовании ключевого слова const допускаются только скалярные выражения (bool, int, float и string) и константы array, содержащие только скалярные выражения.<br><br></div>	t
62	PHP	php	\N	<div><a href="https://www.php.net/manual/ru/intro-whatis.php">Что такое PHP? </a><strong><em><br></em></strong><a href="https://habr.com/ru/post/520472/">PHP </a>(рекурсивный акроним словосочетания PHP: Hypertext Preprocessor) - это распространённый язык программирования общего назначения с открытым исходным кодом. PHP специально сконструирован для веб-разработок и его код может внедряться непосредственно в HTML.<br><br>PHP входит в число языков с <strong>динамической</strong> типизацией. Это значит, что тип данных определяется не при объявлении переменной, а при присваивании значения<br><br>PHP — <strong>интерпретируемый язык</strong>. Написанные на нём программы интерпретируются в момент обращения с помощью специальных программ. Интерпретируемые языки не зависят от платформы, но уступают компилируемым языкам в скорости исполнения.</div><div><br></div><div><br></div>	t
70	Типы данных PHP	tipy-dannykh-php	62	<div><a href="https://www.php.net/manual/ru/language.types.php">Типы данных</a><br><br>PHP поддерживает десять простых типов.</div><div>Четыре скалярных типа:</div><ul><li>bool</li><li>int</li><li>float (число с плавающей точкой, также известное как double)</li><li>string</li></ul><div>Четыре смешанных типа:<br><br></div><ul><li>array</li><li>object</li><li><a href="https://www.php.net/manual/ru/language.types.callable.php">callable</a></li><li><a href="https://www.php.net/manual/ru/language.types.iterable.php">iterable</a></li></ul><div>И, наконец, два специальных типа:<br><br></div><ul><li>resource</li><li>NULL</li></ul><div>Вы также можете найти несколько упоминаний типа двойной точности (double). Рассматривайте его как число с плавающей точкой, два имени существуют только по историческим причинам.<br><br></div><div>Как правило, программист не устанавливает тип переменной; обычно это делает PHP во время выполнения программы в зависимости от контекста, в котором используется переменная.<br><br></div>	t
71	Предопределённые переменные	predopredelionnye-peremennye	63	<div><a href="https://www.php.net/manual/ru/language.variables.predefined.php#language.variables.predefined">Предопределённые переменные <br></a>Любому запускаемому скрипту PHP предоставляет большое количество предопределённых переменных. Однако многие из этих переменных не могут быть полностью задокументированы, поскольку они зависят от запускающего скрипт сервера, его версии и настроек, а также других факторов. Некоторые из этих переменных недоступны, когда PHP запущен из <a href="https://www.php.net/manual/ru/features.commandline.php">командной строки</a>. Смотрите <a href="https://www.php.net/manual/ru/reserved.variables.php">список зарезервированных предопределённых переменных</a> для получения дополнительной информации.</div>	t
72	Суперглобальные переменные	superglobalnye-peremennye	63	<div><a href="https://www.php.net/manual/ru/language.variables.superglobals.php">Суперглобальные переменные</a><br>Суперглобальные переменные — Встроенные переменные, которые всегда доступны во всех областях<br>Некоторые предопределённые переменные в PHP являются "суперглобальными", что означает, что они доступны в любом месте скрипта. Нет необходимости использовать синтаксис <strong>global $variable;</strong> для доступа к ним в функциях и методах.<br><br></div><div>Суперглобальными переменными являются:<br><br></div><ul><li><a href="https://www.php.net/manual/ru/reserved.variables.globals.php"><em>$GLOBALS</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.server.php"><em>$_SERVER</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.get.php"><em>$_GET</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.post.php"><em>$_POST</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.files.php"><em>$_FILES</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.cookies.php"><em>$_COOKIE</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.session.php"><em>$_SESSION</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.request.php"><em>$_REQUEST</em></a></li><li><a href="https://www.php.net/manual/ru/reserved.variables.environment.php"><em>$_ENV</em></a></li></ul>	t
73	Пространство имен	prostranstvo-imen	62	<div><a href="https://www.php.net/manual/ru/language.namespaces.php"><strong><em>Пространство имен(namespace)</em></strong></a><strong><em><br></em></strong>Что такое пространства имён? В широком смысле - это один из способов инкапсуляции элементов. Такое абстрактное понятие можно увидеть во многих местах. Например, в любой операционной системе директории служат для группировки связанных файлов и выступают в качестве пространства имён для находящихся в них файлов. В качестве конкретного примера файл foo.txt может находиться сразу в обеих директориях: /home/greg и /home/other, но две копии foo.txt не могут существовать в одной директории. Кроме того, для доступа к foo.txt извне директории /home/greg, мы должны добавить имя директории перед именем файла используя разделитель, чтобы получить /home/greg/foo.txt. Этот же принцип распространяется и на пространства имён в программировании.<br><br></div><div>В PHP пространства имён используются для решения двух проблем, с которыми сталкиваются авторы библиотек и приложений при создании повторно используемых элементов кода, таких как классы и функции:<br><br></div><ol><li>Конфликт имён между вашим кодом и внутренними классами/функциями/константами PHP или сторонними.</li><li>Возможность создавать псевдонимы (или сокращения) для Ну_Очень_Длинных_Имён, чтобы облегчить первую проблему и улучшить читаемость исходного кода.</li></ol><div>Пространства имён в PHP предоставляют возможность группировать логически связанные классы, интерфейсы, функции и константы<br><br></div>	t
74	Булев	bulev	70	<div><a href="https://www.php.net/manual/ru/language.types.boolean.php">Булев</a><br>Это простейший тип. bool выражает истинность значения. Он может быть либо <strong>true</strong>, либо <strong>false</strong>.<br><br></div>	t
76	SQL	sql	\N	\N	t
85	COMPOSER	composer	\N	<div><a href="https://getcomposer.org/">Composer</a> — это инструмент для управления зависимостями в PHP. Он позволяет вам объявить библиотеки, от которых зависит ваш проект, и он будет управлять (устанавливать/обновлять) их для вас.<br><br></div><div>Управление зависимостями<a href="https://getcomposer.org/doc/00-intro.md#dependency-management"><br></a><br></div><div>Composer <strong>не</strong> является менеджером пакетов в том же смысле, что и Yum или Apt. Да, он имеет дело с «пакетами» или библиотеками, но управляет ими отдельно для каждого проекта, устанавливая их в каталог (например, vendor) внутри вашего проекта. По умолчанию он ничего не устанавливает глобально. Таким образом, это менеджер зависимостей. Однако для удобства он поддерживает «глобальный» проект с помощью <a href="https://getcomposer.org/doc/03-cli.md#global">глобальной</a> команды.<br><br></div>	t
78	SOLID	solid	\N	<div><a href="https://web-creator.ru/articles/solid"><strong>SOLID</strong></a></div><ul><li>Single responsibility — принцип единственной ответственности</li><li>Open-closed — принцип открытости / закрытости</li><li>Liskov substitution — принцип подстановки Барбары Лисков</li><li>Interface segregation — принцип разделения интерфейса</li><li>Dependency inversion — принцип инверсии зависимостей</li></ul><div><br></div>	t
77	PHP ООП	php-oop	\N	<div>PHP включает полноценную объектную модель. Некоторые из её особенностей: <a href="https://www.php.net/manual/ru/language.oop5.visibility.php">видимость</a>, <a href="https://www.php.net/manual/ru/language.oop5.abstract.php">абстрактные</a> и <a href="https://www.php.net/manual/ru/language.oop5.final.php">ненаследуемые</a> (final) классы и методы, а также <a href="https://www.php.net/manual/ru/language.oop5.magic.php">магические методы</a>, <a href="https://www.php.net/manual/ru/language.oop5.interfaces.php">интерфейсы</a> и <a href="https://www.php.net/manual/ru/language.oop5.cloning.php">клонирование</a>.<br><br></div><div>PHP работает с объектами так же, как с ссылками или дескрипторами, это означает что каждая переменная содержит ссылку на объект, а не его копию. Более подробную информацию смотрите в разделе <a href="https://www.php.net/manual/ru/language.oop5.references.php">Объекты и ссылки</a>.<br><br></div>	t
82	INT	int	75	<div>Целые числа (int) могут быть указаны в десятичной (основание 10), шестнадцатеричной (основание 16), восьмеричной (основание 8) или двоичной (основание 2) системе счисления. Для задания отрицательных целых (int) используется <a href="https://www.php.net/manual/ru/language.operators.arithmetic.php">оператор отрицания<br></a><br></div><div>Для записи в восьмеричной системе счисления, необходимо поставить перед числом 0 (ноль). Начиная с PHP 8.1.0, восьмеричной нотации также может предшествовать 0o или 0O. Для записи в шестнадцатеричной системе счисления, необходимо поставить перед числом 0x. Для записи в двоичной системе счисления, необходимо поставить перед числом 0b<br><br></div><div>Начиная с PHP 7.4.0, целочисленные литералы могут содержать подчёркивания (_) между цифрами для лучшей читаемости литералов. Эти подчёркивания удаляются сканером PHP.</div>	t
75	Целые числа	tselye-chisla	70	<div><a href="https://www.php.net/manual/ru/language.types.integer.php">Целые числа</a><br>int - это число из множества ℤ = {..., -2, -1, 0, 1, 2, ...}.<br><br></div><div>Смотрите также:<br><br></div><ul><li><a href="https://www.php.net/manual/ru/book.gmp.php">Вычисления над целыми числами с произвольной точностью (GNU Multiple Precision)</a></li><li><a href="https://www.php.net/manual/ru/language.types.float.php">Числа с плавающей точкой</a></li><li><a href="https://www.php.net/manual/ru/book.bc.php">Вычисления над числами с произвольной точностью BCMath</a></li></ul><div>Синтаксис...&gt;<a href="https://www.php.net/manual/ru/language.types.integer.php#language.types.integer.syntax"><br></a><br></div><div><br></div>	t
95	Callback-функции	callback-funktsii	70	<div><a href="https://www.php.net/manual/ru/language.types.callable.php">Функции обратного вызова (callback-функции)</a><br>Callback-функции могут быть обозначены объявлением типа <a href="https://www.php.net/manual/ru/language.types.callable.php">callable</a>.<br><br></div><div>Некоторые функции, такие как <a href="https://www.php.net/manual/ru/function.call-user-func.php">call_user_func()</a> или <a href="https://www.php.net/manual/ru/function.usort.php">usort()</a>, принимают определённые пользователем callback-функции в качестве параметра. Callback-функции могут быть как простыми функциями, так и методами объектов, включая статические методы классов.<br><br></div><div><br></div><div><br></div>	t
81	Float, double	float-double	70	<div><a href="https://www.php.net/manual/ru/language.types.float.php">Числа с плавающей точкой </a>или числа с плавающей запятой (также известные как "float", "double" или "real")&nbsp;</div>	t
86	Строки	stroki	70	<div><a href="https://www.php.net/manual/ru/language.types.string.php">Строки</a><br>Строка (тип string) - это набор символов, где символ - это то же самое, что и байт. Это значит, что PHP поддерживает ровно 256 различных символов, а также то, что в PHP нет встроенной поддержки Unicode. Смотрите также <a href="https://www.php.net/manual/ru/language.types.string.php#language.types.string.details">подробности реализации строкового типа</a>.<br>Строка может быть определена четырьмя различными способами:<br><br></div><ul><li><a href="https://www.php.net/manual/ru/language.types.string.php#language.types.string.syntax.single">одинарными кавычками</a></li><li><a href="https://www.php.net/manual/ru/language.types.string.php#language.types.string.syntax.double">двойными кавычками</a></li><li><a href="https://www.php.net/manual/ru/language.types.string.php#language.types.string.syntax.heredoc">heredoc-синтаксисом</a></li><li><a href="https://www.php.net/manual/ru/language.types.string.php#language.types.string.syntax.nowdoc">nowdoc-синтаксисом</a></li></ul><div><br></div><div><br><br></div>	t
87	Числовые строки	chislovye-stroki	70	<div><a href="https://www.php.net/manual/ru/language.types.numeric-strings.php">Числовые строки</a><br>В PHP, строка (string) считается числовой, если её можно интерпретировать как целое (int) число или как число с плавающей точкой (float).<br><br></div><div>Формально с PHP 8.0.0:<br><br></div><pre>WHITESPACES      \\s*\r\nLNUM             [0-9]+\r\nDNUM             ([0-9]*)[\\.]{LNUM}) | ({LNUM}[\\.][0-9]*)\r\nEXPONENT_DNUM    (({LNUM} | {DNUM}) [eE][+-]? {LNUM})\r\nINT_NUM_STRING   {WHITESPACES} [+-]? {LNUM} {WHITESPACES}\r\nFLOAT_NUM_STRING {WHITESPACES} [+-]? ({DNUM} | {EXPONENT_DNUM}) {WHITESPACES}\r\nNUM_STRING       ({INT_NUM_STRING} | {FLOAT_NUM_STRING})\r\n<br></pre><div>В PHP также присутствует концепция <em>префиксной</em> числовой строки. Это строка, которая начинается как числовая и продолжается любыми другими символами.<br><br></div><div>Строки, используемые в числовых контекстах<a href="https://www.php.net/manual/ru/language.types.numeric-strings.php#language.types.numeric-string.conversion"> ¶<br></a><br></div><div>Когда строку необходимо использовать в качестве числа (например арифметические операции, декларация целочисленного типа, и т.д.), используется следующий алгоритм действий:<br><br></div><ol><li>Если строка числовая, представляет целое число и не превышает максимально допустимого значения для типа int (определённого в <strong>PHP_INT_MAX</strong>), то она приводится к типу int. Иначе она приводится к типу float.</li><li>Если в заданном контексте дозволительно использовать префиксную числовую строку, то, если начало строки представляет целое число и не превышает максимально допустимого значения для типа int (определённого в <strong>PHP_INT_MAX</strong>), то она приводится к типу int. Иначе она приводится к типу float. Также, в этом случае, выдаётся ошибка уровня <strong>E_WARNING</strong>.</li><li>Если строка не числовая - выбрасывается исключение <a href="https://www.php.net/manual/ru/class.typeerror.php">TypeError</a>.</li></ol><div><br></div>	t
88	Массивы	massivy	70	<div><a href="https://www.php.net/manual/ru/language.types.array.php">Массивы</a><br>На самом деле массив в PHP - это упорядоченное отображение, которое устанавливает соответствие между <em>значением</em> и <em>ключом</em>. Этот тип оптимизирован в нескольких направлениях, поэтому вы можете использовать его как собственно массив, список (вектор), хеш-таблицу (являющуюся реализацией карты), словарь, коллекцию, стек, очередь и, возможно, что-то ещё. Так как значением массива может быть другой массив PHP, можно также создавать деревья и многомерные массивы.</div><div><br></div>	t
89	EXCEPTION	exception	\N	<div><strong>Exception</strong> — это базовый класс для всех пользовательских исключений.<br>Модель исключений (exceptions) в PHP похожа с используемыми в других языках программирования. Исключение можно сгенерировать (выбросить) при помощи оператора <a href="https://www.php.net/manual/ru/language.exceptions.php">throw</a>, и можно перехватить (поймать) оператором <a href="https://www.php.net/manual/ru/language.exceptions.php#language.exceptions.catch">catch</a>. Код генерирующий исключение, должен быть окружён блоком <a href="https://www.php.net/manual/ru/language.exceptions.php">try</a>, для того, чтобы можно было перехватить исключение. Каждый блок <a href="https://www.php.net/manual/ru/language.exceptions.php">try</a> должен иметь как минимум один соответствующий ему блок <a href="https://www.php.net/manual/ru/language.exceptions.php#language.exceptions.catch">catch</a> или <a href="https://www.php.net/manual/ru/language.exceptions.php#language.exceptions.finally">finally</a>.</div><div><br></div>	t
113	Абстрактная фабрика	abstraktnaia-fabrika	109	<div><strong>Абстрактная фабрика</strong> — это порождающий паттерн проектирования, который позволяет создавать семейства связанных объектов, не привязываясь к конкретным классам создаваемых объектов.<br><strong><br>&nbsp;Структура</strong><br><br></div><ol><li><strong>Абстрактные продукты</strong> объявляют интерфейсы продуктов, которые связаны друг с другом по смыслу, но выполняют разные функции.</li><li><strong>Конкретные продукты</strong> — большой набор классов, которые относятся к различным абстрактным продуктам (кресло/столик), но имеют одни и те же вариации (Викторианский/Модерн).</li><li><strong>Абстрактная фабрика</strong> объявляет методы создания различных абстрактных продуктов (кресло/столик).</li><li><strong>Конкретные фабрики</strong> относятся каждая к своей вариации продуктов (Викторианский/Модерн) и реализуют методы абстрактной фабрики, позволяя создавать все продукты определённой вариации.</li><li>Несмотря на то, что конкретные фабрики порождают конкретные продукты, сигнатуры их методов должны возвращать соответствующие абстрактные продукты. Это позволит клиентскому коду, использующему фабрику, не привязываться к конкретным классам продуктов. Клиент сможет работать с любыми вариациями продуктов через абстрактные интерфейсы.</li></ol><div><br></div><div><br></div><div><br><br></div>	t
90	Итерируемые	iteriruemye	70	<div><a href="https://www.php.net/manual/ru/language.types.iterable.php">Итерируемые</a><br><a href="https://www.php.net/manual/ru/language.types.iterable.php">Iterable</a> - псевдотип, введённый в PHP 7.1. Он принимает любой массив (array) или объект, реализующий интерфейс <a href="https://www.php.net/manual/ru/class.traversable.php">Traversable</a>. Оба этих типа итерируются с помощью <a href="https://www.php.net/manual/ru/control-structures.foreach.php">foreach</a> и могут быть использованы с <strong>yield from</strong> в <a href="https://www.php.net/manual/ru/language.generators.php">генераторах</a>.<br><br></div><div>Использование Iterable<a href="https://www.php.net/manual/ru/language.types.iterable.php#language.types.iterable.using">&nbsp;</a></div><div>Тип iterable может использоваться как тип параметра для указания, что функция принимает набор значений, но ей не важна форма этого набора, пока он будет использоваться с <a href="https://www.php.net/manual/ru/control-structures.foreach.php">foreach</a>. Если значение не является массивом или объектом, реализующим <a href="https://www.php.net/manual/ru/class.traversable.php">Traversable</a>, будет выброшено исключение <a href="https://www.php.net/manual/ru/class.typeerror.php">TypeError</a>.<br><br></div><div><br></div><div><br></div>	t
91	Объекты	obekty	70	<div><a href="https://www.php.net/manual/ru/language.types.object.php">Объекты</a></div><div>Инициализация объекта<a href="https://www.php.net/manual/ru/language.types.object.php#language.types.object.init">&nbsp;</a></div><div>Для создания нового объекта, используйте выражение new, создающее в переменной экземпляр класса:<br><br></div><div>&lt;?php<br>class foo<br>{<br>&nbsp; &nbsp; function do_foo()<br>&nbsp; &nbsp; {<br>&nbsp; &nbsp; &nbsp; &nbsp; echo "Код foo.";<br>&nbsp; &nbsp; }<br>}<br><br>$bar = new foo;<br>$bar-&gt;do_foo();<br>?&gt;<br>Если object преобразуется в object, объект не изменится. Если значение другого типа преобразуется в object, создаётся новый экземпляр встроенного класса stdClass. Если значение было <strong>null</strong>, новый экземпляр будет пустым. Массивы преобразуются в object с именами полей, названными согласно ключам массива и соответствующими им значениям. Обратите внимание, что в этом случае до PHP 7.2.0 числовые ключи не будут доступны, пока не проитерировать объект.</div>	t
92	Перечисления	perechisleniia	70	<div><a href="https://www.php.net/manual/ru/language.types.enumerations.php">Перечисления</a></div><div>Перечисления - это ограничивающий слой над классами и константами классов, предназначенный для предоставления способа определения закрытого набора возможных значений для типа.<br>&lt;?php<br>enum Suit<br>{<br>&nbsp; &nbsp; case Hearts;<br>&nbsp; &nbsp; case Diamonds;<br>&nbsp; &nbsp; case Clubs;<br>&nbsp; &nbsp; case Spades;<br>}<br><br>function do_stuff(Suit $s)<br>{<br>&nbsp; &nbsp; // ...<br>}<br><br>do_stuff(Suit::Spades);<br>?&gt;<br>Если перечисление (enum) преобразуется в объект (object), оно не изменяется. Если перечисление (enum) преобразуется в массив (array), массив с одним ключом name (для простых перечислений) или массив с обоими ключами name и value (для типизированных перечислений). Все остальные приведения типов приведут к ошибке.</div><div><br></div>	t
93	Ресурс	resurs	70	<div><a href="https://www.php.net/manual/ru/language.types.resource.php">Ресурс</a><br>Resource - это специальная переменная, содержащая ссылку на внешний ресурс. Ресурсы создаются и используются специальными функциями. Полный перечень этих функций и соответствующих типов ресурсов (resource) смотрите в <a href="https://www.php.net/manual/ru/resource.php">приложении</a>.<br><br></div><div>Смотрите также описание функции <a href="https://www.php.net/manual/ru/function.get-resource-type.php">get_resource_type()</a>.<br><br></div><div>Преобразование в ресурс<a href="https://www.php.net/manual/ru/language.types.resource.php#language.types.resource.casting">&nbsp;</a></div><div>Поскольку тип resource содержит специальные указатели на открытые файлы, соединения с базой данных, области изображения и тому подобное, преобразование в этот тип не имеет смысла.<br><br></div><div><br></div>	t
94	NULL	null	70	<div><a href="https://www.php.net/manual/ru/language.types.null.php">NULL</a><br>Специальное значение <strong>null</strong> представляет собой переменную без значения. <strong>null</strong> - это единственно возможное значение типа null.<br><br></div><div>Переменная считается null, если:<br><br></div><ul><li>ей была присвоена константа <strong>null</strong>.</li><li>ей ещё не было присвоено никакого значения.</li><li>она была удалена с помощью <a href="https://www.php.net/manual/ru/function.unset.php">unset()</a>.<br><br></li></ul><div>Синтаксис<a href="https://www.php.net/manual/ru/language.types.null.php#language.types.null.syntax">&nbsp;</a></div><div>Существует только одно значение типа null - регистронезависимая константа <strong>null</strong>.<br><br></div><div><br></div>	t
114	Строитель	stroitel	109	<div><strong>Строитель</strong> — это порождающий паттерн проектирования, который позволяет создавать сложные объекты пошагово. Строитель даёт возможность использовать один и тот же код строительства для получения разных представлений объектов.<br><strong><br>&nbsp;Структура</strong><br><br></div><ol><li><strong>Интерфейс строителя</strong> объявляет шаги конструирования продуктов, общие для всех видов строителей.</li><li><strong>Конкретные строители</strong> реализуют строительные шаги, каждый по-своему. Конкретные строители могут производить разнородные объекты, не имеющие общего интерфейса.</li><li><strong>Продукт</strong> — создаваемый объект. Продукты, сделанные разными строителями, не обязаны иметь общий интерфейс.</li><li><strong>Директор</strong> определяет порядок вызова строительных шагов для производства той или иной конфигурации продуктов.</li><li>Обычно <strong>Клиент</strong> подаёт в конструктор директора уже готовый объект-строитель, и в дальнейшем данный директор использует только его. Но возможен и другой вариант, когда клиент передаёт строителя через параметр строительного метода директора. В этом случае можно каждый раз применять разных строителей для производства различных представлений объектов.</li></ol>	t
96	Объявление типов	obiavlenie-tipov	70	<div><a href="https://www.php.net/manual/ru/language.types.declarations.php">Объявление типов</a><br>Объявления типов могут использоваться для аргументов функций, возвращаемых значений и, начиная с PHP 7.4.0, для свойств класса. Они используются во время исполнения для проверки, что значение имеет точно тот тип, который для них указан. В противном случае будет выброшено исключение <a href="https://www.php.net/manual/ru/class.typeerror.php">TypeError</a>.<br><br></div><blockquote><strong>Замечание</strong>:При переопределении родительского метода, тип возвращаемого значения дочернего метода должен соответствовать любому объявлению возвращаемого типа родительского. Если в родительском методе тип возвращаемого значения не объявлен, то это можно сделать в дочернем.</blockquote><div><br></div>	t
97	Манипуляции с типами	manipuliatsii-s-tipami	70	<div><a href="https://www.php.net/manual/ru/language.types.type-juggling.php">Манипуляции с типами</a><br>PHP не требует явного определения типа при объявлении переменной. В этом случае тип переменной определяется значением, которое она хранит. То есть, если переменной $var присваивается значение типа строка (string), то $var изменит тип на строку (string). Если после этого переменной $var будет присвоено значение типа целое число (int), то она изменит тип на целое число (int).<br><br></div><div>В определённых контекстах PHP может попытаться автоматически преобразовать тип значения в другой. Существуют следующие различные контексты:<br><br></div><ul><li>Числовой контекст</li><li>Строчный контекст</li><li>Логический контекст</li><li>Контекст целых чисел и строк</li><li>Сравнительный контекст</li><li>Контекст функций</li></ul><div><br></div><blockquote><strong>Замечание</strong>: Когда значение нужно интерпретировать как другой тип, само значение <em>не</em> меняет тип.</blockquote><div><br>Чтобы принудительно установить тип переменной, смотрите раздел <a href="https://www.php.net/manual/ru/language.types.type-juggling.php#language.types.typecasting">Приведение типа</a>. Чтобы изменить тип переменной, смотрите описание функции <a href="https://www.php.net/manual/ru/function.settype.php">settype()</a>.<br><br></div><div><br></div>	t
84	DOKER	doker	\N	<div>Докер — это открытая платформа для разработки, доставки и эксплуатации приложений. Docker разработан для более быстрого выкладывания ваших приложений. С помощью docker вы можете отделить ваше приложение от вашей инфраструктуры и обращаться с инфраструктурой как управляемым приложением. Docker помогает выкладывать ваш код быстрее, быстрее тестировать, быстрее выкладывать приложения и уменьшить время между написанием кода и запуска кода. Docker делает это с помощью легковесной платформы контейнерной виртуализации, используя процессы и утилиты, которые помогают управлять и выкладывать ваши приложения.</div>	t
98	Single responsibility	single-responsibility	78	<div><a href="https://web-creator.ru/articles/solid_the_single_responsibility_principle"><strong>Принцип единственной ответственности </strong></a><strong>— The Single Responsibility Principle или SRP — один из пяти основных принципов объектно-ориентированного программирования и проектирования, сформулированных Робертом Мартином.<br></strong><br></div><div>Принцип декларирует, что каждый объект должен иметь одну обязанность и эта обязанность должна быть полностью инкапсулирована в класс, а все его сервисы должны быть направлены исключительно на обеспечение этой обязанности.<br><br></div><div>Следование принципу заключается обычно в декомпозиции сложных классов, которые делают сразу много вещей, на простые, отвественность которых очень специализирована. Но также и объединении в отдельный класс однотипной функциональности, которая может оказаться распределённой по многим классам, может рассматриваться как следование этому принципу.<br><br></div><div>Проектирование классов с направленностью на обеспечение единственной обязанности упрощает дальнейшие модификации и сопровождение, так как проще разобраться в одном блоке функциональности, нежели распутывать сложные взаимосвязи между различными функциональными блоками. Также при модификации логики в одном месте приложения снижаются риски возникновения проблем в других «неожиданных» его местах.<br><br></div><div><strong><br></strong><br></div>	t
99	Open-closed	open-closed	78	<div><a href="https://web-creator.ru/articles/solid_the_open_closed_principle"><strong>Принцип открытости/закрытости </strong></a><strong>— The Open Closed Principle или OCP — один из пяти основных принципов объектно-ориентированного программирования и проектирования, сформулированных Робертом Мартином.<br></strong><br></div><div>Принцип декларирует, что программные сущности (классы, модули, функции и т. п.) должны быть открыты для расширения, но закрыты для изменения. Это означает, что эти сущности могут менять свое поведение без изменения их исходного кода.<br><br></div><div>В этом контексте открытость для расширения — это возможность добавить для класса, модуля или функции новое поведение, если необходимость в этом возникнет, а закрытость для изменений — это запрет на изменение исходного кода&nbsp; программных сущностей. На первый взгляд, это звучит сложно и противоречиво. Но если разобраться, то принцип вполне логичен.<br><br></div><div>Следование принципу OCP заключается в том, что программное обеспечение изменяется не через изменение существующего кода, а через добавление нового кода. То есть созданный изначально код остаётся «нетронутым» и стабильным, а новая функциональность внедряется либо через наследование реализации, либо через использование абстрактных интерфейсов и полиморфизм.<br><br></div>	t
102	Dependency inversion	dependency-inversion	78	<div><a href="https://web-creator.ru/articles/solid_the_dependency_inversion_principle"><strong>Принцип инверсии зависимостей</strong></a><strong> — The Dependency Inversion Principle или DIP — один из пяти основных принципов объектно-ориентированного программирования и проектирования, сформулированных Робертом Мартином.<br></strong><br></div><div>Принцип декларирует, что модули верхних уровней не должны зависеть от модулей нижних уровней, а оба типа модулей должны зависеть от абстракций; сами абстракции не должны зависеть от деталей, а вот детали должны зависеть от абстракций.<br><br></div><div>Следование принципу инверсии зависимостей «заставляет» реализовывать высокоуровневые компоненты без встраивания зависимостей от конкретных низкоуровневых классов, что, например, сильно упрощает замену используемых зависимостей как по изнес-требованиям, так и для целей тестирования. При этом зависимость формируется не от конкретной реализации, а от абстракции — реализуемого зависимостью интерфейса.<br><br></div><div>Например, мы реализуем хранение документов в веб-приложении. На первый взгляд, кажется логичным добавить зависимость от модулей работы с файловой системой непосредственно в класс, отвечающий за высокоуровневую работу с этими документами. Но в перспективе такая зависимость может создать проблемы — например, нам потребуется хранить данные не только на диске, но и в облаке. Если зависимость внедрена от реализации, то мы столкнёмся с необходимостью её переработки. Если же зависимость выведена на уровень абстракции (интерфейса), то нам будет достаточно реализовать функционал работы с облаком, соответствующий ранее созданному интерфейсу работы с файлами.<br><br></div><div>Принцип инверсии зависимостей часто упрощает следованию принципу подстановки Барбары Лисков. Выделение абстракций и встраивание зависимостей от них снижает вероятность того, что в новом классе мы не полностью реализуем контракт базового класса, который мы расширяем в рамках нового.<br><br></div>	t
101	Interface segregation	interface-segregation	78	<div><a href="https://web-creator.ru/articles/solid_the_interface_segregation_principle"><strong>Принцип разделения интерфейса</strong></a><strong> — The Interface Segregation Principle или ISP — один из пяти основных принципов объектно-ориентированного программирования и проектирования, сформулированных Робертом Мартином.<br></strong><br></div><div>Принцип в формулировке Роберта Мартина декларирует, что клиенты не должны зависеть от методов, которые они не используют. То есть если какой-то метод интерфейса не используется клиентом, то изменения этого метода не должны приводить к необходимости внесения изменений в клиентский код.<br><br></div><div>Следование принципу ISP заключается в создании интерфейсов, которые достаточно специфичны и требуют только необходимый минимум реализаций методов. Избыточные интерфейсы, напротив, могут требовать от реализующего класса создание большого количества методов, причём даже таких, которые не имеют смысла в контексте класса.<br><br></div><div>В чём-то принцип разделения интерфейса перекликается с принципом единственной ответственности — интерфейсы не должны быть избыточно «толстыми», если вдруг в приложении формируется слишком объёмный интерфейс, то есть высокая вероятность, что так происходит из-за того, что в этом интерфейсе слишком много разных ответственностей, а значит логичнее всего провести декомпозицию сложного интерфейса на несколько простых.<br><br></div><div>Принцип разделения интерфейса снижает сложность поддержки и развития приложения. Чем проще и минималистичнее используемый интерфейс, тем менее ресурсоёмкой является его реализация в новых классах, тем меньше причин его модифицировать, но и в случае модификации она будет значительно проще.<br><br></div>	t
100	Liskov substitution	liskov-substitution	78	<div><a href="https://web-creator.ru/articles/solid_the_liskov_substitution_principle"><strong>Принцип подстановки Барбары Лисков</strong></a><strong> — The Liskov Substitution Principle или LSP — один из пяти основных принципов объектно-ориентированного программирования и проектирования, сформулированных Робертом Мартином.</strong><br>Принцип в формулировке Роберта Мартина декларирует, что функции, которые используют базовый тип, должны иметь возможность использовать подтипы базового типа не зная об этом. Оригинальное определение Барбары Лисков более формальное и заметно сложнее для восприятия: «В том случае, если q(x) — свойство, верное по отношению к объектам х некого типа T, то свойство q(y) тоже будет верным относительно ряда объектов y, которые относятся к типу S, при этом S — подтип некого типа T».<br><br></div><div>Следование принципу LSP заключается в том, что при построении иерархий наследования создаваемые наследники должны корректно реализовывать поведение базового типа. То есть если базовый тип реализует определённое поведение, то это поведение должно быть корректно реализовано и для всех его наследников.<br><br></div><div>LSP перекликается с контрактным программированием, определяя точные, формальные и верифицируемые описания интерфейсов. И интерфейсы, реализумые наследниками, должны соответствовать контракту интерфейсов базового класса.<br><br></div><div>Наследник класса дополняет, но не заменяет поведение базового класса. То есть в любом месте программы замена базового класса на класс-наследник не должна вызывать проблем. Если по каким-то причинам так не получается, то вероятнее всего имеет место либо некорректная реализация, либо неверно выбранная абстракция для наследования.<br><br></div>	t
103	KISS	kiss	79	<div><a href="https://web-creator.ru/articles/kiss"><strong>Принцип программирования KISS-</strong></a><strong> делай вещи проще</strong><br><strong>Большая часть программных систем необосновано перегружена практически ненужными функциями, что ухудшает удобство их использование конечными пользователями, а также усложняет их поддержку и развитие разработчиками. Следование принципу «KISS» позволяет разрабатывать решения, которые просты в использовании и в сопровождении.<br></strong><br></div><div>KISS — это принцип проектирования и программирования, при котором простота системы декларируется в качестве основной цели или ценности. Есть два варианта расшифровки аббревиатуры: «keep it simple, stupid» и более корректный «keep it short and simple».<br><br></div><div><strong>В проектировании следование принципу KISS выражается в том, что:<br></strong><br></div><ul><li>не имеет смысла реализовывать дополнительные функции, которые не будут использоваться вовсе или их использование крайне маловероятно, как правило, большинству пользователей достаточно базового функционала, а усложнение только вредит удобству приложения;</li><li>не стоит перегружать интерфейс теми опциями, которые не будут нужны большинству пользователей, гораздо проще предусмотреть для них отдельный «расширенный» интерфейс (или вовсе отказаться от данного функционала);</li><li>бессмысленно делать реализацию сложной бизнес-логики, которая учитывает абсолютно все возможные варианты поведения системы, пользователя и окружающей среды, — во-первых, это просто невозможно, а во-вторых, такая фанатичность заставляет собирать «звездолёт», что чаще всего иррационально с коммерческой точки зрения.</li></ul><div><strong>В программировании следование принципу KISS можно описать так:<br></strong><br></div><ul><li>не имеет смысла беспредельно увеличивать уровень абстракции, надо уметь вовремя остановиться;</li><li>бессмысленно закладывать в проект избыточные функции «про запас», которые может быть когда-нибудь кому-либо понадобятся (тут скорее правильнее <a href="https://web-creator.ru/articles/yagni">подход согласно принципу YAGNI</a>);</li><li>не стоит подключать огромную библиотеку, если вам от неё нужна лишь пара функций;</li><li>декомпозиция чего-то сложного на простые составляющие — это архитектурно верный подход (тут KISS перекликается с <a href="https://web-creator.ru/articles/dry">DRY</a>);</li><li>абсолютная математическая точность или предельная детализация нужны не всегда — большинство систем создаются не для запуска космических шаттлов, данные можно и нужно обрабатывать с той точностью, которая достаточна для качественного решения задачи, а детализацию выдавать в нужном пользователю объёме, а не в максимально возможном объёме.</li></ul><div>Также KISS имеет много общего <a href="https://web-creator.ru/articles/solid_the_interface_segregation_principle">c принципом разделения интерфейса</a> <a href="https://web-creator.ru/articles/solid">из пяти принципов SOLID</a>, сформулированных Робертом Мартином.<br><br></div><div><br></div>	t
104	DRY	dry	79	<div><strong>Следование принципу программирования </strong><a href="https://web-creator.ru/articles/dry"><strong>«DRY»</strong></a><strong> позволяет добиться высокой сопровождаемости проекта, простоты внесения изменений и качественного тестирования.<br></strong><br></div><div>Если код не дублируется, то для изменения логики достаточно внесения исправлений всего в одном месте и проще тестировать одну (пусть и более сложную) функцию, а не набор из десятков однотипных. Следование принципу DRY всегда приводит к декомпозиции сложных алгоритмов на простые функции. А декомпозиция сложных операций на более простые (и повторно используемые) значительно упрощает понимание программного кода. Повторное использование функций, вынесенных из сложных алгоритмов, позволяет сократить время разработки и тестирования новой функциональности.<br><br></div><div>Следование принципу DRY приводит к модульной архитектуре приложения и к чёткому разделению ответственности за бизнес-логику между программными классами. А это — залог сопровождаемой архитектуры. Хотя чаще не DRY приводит к модульности, а уже модульность, в свою очередь, обеспечивает принципиальную возможность соблюдения этого принципа в больших проектах.<br><br></div><div>В рамках одного программного класса (или модуля) следовать DRY и не повторяться обычно достаточно просто. Также не требует титанических усилий делать это в рамках небольших проектов, где все разработчики «владеют» всем кодом системы. А вот в больших проектах ситуация с DRY несколько сложнее — повторы чаще всего появляются из-за отсутствия у разработчиков целостной картины или несогласованности действий в рамках команды. Следовать принципу «don’t repeat yourself» в рамках больших проектов не так просто, как это может показаться на первый взгляд. От разработчиков требуется тщательное планирование архитектуры, а от архитектора или тимлида требуется наличие видения системы в целом и чёткая постановка задач разработчикам.<br><br></div><div>В пректировании DRY тоже имеет место — доступ к конкретному функционалу должен быть доступен в одном месте, унифицирован и сгруппирован по какому-либо принципу, а не «разбросан» по системе в произвольных вариациях. Этот подход пересекается <a href="https://web-creator.ru/articles/solid_the_single_responsibility_principle">с принципом единственной ответственности</a> <a href="https://web-creator.ru/articles/solid">из пяти принципов SOLID</a>, сформулированных Робертом Мартином.<br><br></div>	t
105	YAGNI	yagni	79	<div><strong>Если упрощенно, то следование принципу </strong><a href="https://web-creator.ru/articles/yagni"><strong>YAGNI</strong></a> <strong>заключается в том, что возможности, которые не описаны в требованиях к системе, просто не должны реализовываться. Это позволяет вести разработку, руководствуясь экономическими критериями — Заказчик не должен оплачивать ненужные ему функции, а разработчики не должны тратить своё оплачиваемое время на реализацию того, что не требуется.<br></strong><br></div><div>Основная проблема, которую решает принцип YAGNI — это устранение тяги программистов к излишней абстракции, к экспериментам «из интереса» и к реализации функционала, который сейчас не нужен, но, по мнению разработчика, может либо вскоре понадобиться, либо просто будет полезен, хотя в реальности такого очень часто не происходит.<br><br></div><div>«Бесплатных» функций в программных продуктах просто не бывает. Если рассматривать материальную сторону, то любые ненужные, но фактически реализованные «фичи» оплачиваются либо Заказчиком (в бюджет закладываются расходы на те функции, которые не нужны), либо Исполнителем из прибыли по проекту. И тот, и другой варианты с точки зрения бизнеса неверны. Если же говорить о нематериальных затратах, то любые «бонусные» возможности усложняют сопровождение, увеличивают вероятность ошибок и усложняют взаимодействие с продуктом, — между объёмом кодовой базы и описанными характеристиками есть прямая зависимость. Больше написанного кода — труднее сопровождать и выше вероятность появления «багов», тут очень уместна поговорка: «лучший код — это ненаписанный код».<br><br></div><div>Принципы YAGNI и <a href="https://web-creator.ru/articles/kiss">KISS</a> очень похожи, если KISS нацелен на упрощение и полезен в плане работы с теми требованиями, которые имеют место быть, то YAGNI более категоричен и применяется для ограждения проектов по разработке ПО от «размывания» их рамок.<br><br></div><div><strong>Подход к реализации проектов строго по ТЗ верен с нескольких ракурсов. Заказчик не должен платить за то, что ему не надо, а продукт должен быть максимально сопровождаем и его качество не должно страдать от интеграции ненужных функций.<br></strong><br></div>	t
106	Кэширование	keshirovanie	62	<div><a href="https://maxsite.org/page/cache-in-php#:~:text=%D0%9A%D1%8D%D1%88%D0%B8%D1%80%D0%BE%D0%B2%D0%B0%D0%BD%D0%B8%D0%B5%20%E2%80%94%20%D1%8D%D1%82%D0%BE%20%D0%BE%D0%B4%D0%B8%D0%BD%20%D0%B8%D0%B7%20%D1%81%D0%BF%D0%BE%D1%81%D0%BE%D0%B1%D0%BE%D0%B2,%D0%B1%D1%83%D0%B4%D0%B5%D1%82%20%D0%BE%D1%82%D0%B4%D0%B0%D0%BD%D1%8B%20%D0%B4%D0%B0%D0%BD%D0%BD%D1%8B%D0%B5%20%D0%B8%D0%B7%20%D0%BA%D1%8D%D1%88%D0%B0.">Кэширование</a> — это один из способов ускорить ваш код. Смысл любого кэширования состоит в том, чтобы организовать некий буфер, в котором будет храниться уже готовый результат выполнения: то есть вместо выполнения кода, будет отданы данные из кэша.<br><br></div><div>Использовать кэш нужно в тех участках кода, которые являются наиболее ресурсозатратными. Например длинные циклы или обработка файлов. Также кэширование применяются в функциях, которые могут быть вызваны много раз в коде.<br><br></div><div>Совершенно бессмысленно создавать кэш для функций, которые редко вызываются в коде. В этом случае затраты на кэширование просто не «окупаются».<br><br></div><div>Существует два основных подхода к организации кэша: в файле и в памяти.<br><br></div>	t
79	KISS, DRY, YAGNI	kiss-dry-yagni	\N	<div><strong>YAGNI</strong></div><div><em>You Aren’t Gonna Need It / Вам это не понадобится<br></em>Не пишите код, если думаете, что он пригодится позже.<br><em><br></em><strong>DRY</strong></div><div><em>Don’t Repeat Yourself / Не повторяйтесь<br></em>Дублирование кода – пустая трата времени и ресурсов.<br><em><br></em><strong>KISS</strong></div><div><em>Keep It Simple, Stupid / Будь проще<br>П</em>ростые системы будут работать лучше и надежнее.</div>	t
107	Работа с ссылками	rabota-s-ssylkami	62	<div>Ссылки в PHP — это, грубо говоря, способ получить доступ к одной и той же переменной (области памяти) под разными именами.<br><br>Основные операции которые можно совершать с ссылками:<br><br></div><ul><li><a href="https://www.php.net/manual/ru/language.references.pass.php">Передача по ссылке</a></li><li><a href="https://www.php.net/manual/ru/language.references.whatdo.php#language.references.whatdo.assign">Присвоение по ссылке</a></li><li><a href="https://www.php.net/manual/ru/language.references.return.php">Возврат по ссылке</a></li><li><a href="https://www.php.net/manual/ru/language.references.spot.php">Неявное использование механизма ссылок</a></li></ul><div><br>Важно понимать особенности с передачей объектов. Вы могли читать, что в php все объекты передаются по ссылке<br>Это было верно до php5, но сейчас передается только идентификатор объекта (<a href="https://www.php.net/manual/ru/language.oop5.references.php">документация</a>).<br>Если вкратце, если вы создали объект, и передали его в функцию, внутри которой вы сделали</div><pre>$object = <strong>null</strong>;</pre><div>это не значит что оригинальный объект тоже обнулится, вы все так же можете с ним работать. А вот если вы явно передали объект по ссылке — то это действие “обнулит” и оригинальный объект.</div>	t
63	Переменные	peremennye	62	<div><a href="https://www.php.net/manual/ru/language.variables.php">Переменные</a> в PHP представлены знаком доллара с последующим именем переменной. Имя переменной чувствительно к регистру они используются для хранения значений, таких как текстовые строки, числа или массивы. Когда переменная объявлена, она может быть использована снова и снова в вашем скрипте.<br><br></div><div><a href="https://www.php.net/manual/ru/language.variables.predefined.php">Предопределённые переменные</a><br><br></div><div><a href="https://www.php.net/manual/ru/language.variables.superglobals.php">Суперглобальные переменные</a> — Встроенные переменные, которые всегда доступны во всех областях<br><br></div><div><br></div><div><br></div>	t
108	Работа с массивами	rabota-s-massivami	62	<div><a href="https://www.php.net/manual/ru/ref.array.php"><strong>Функции для работы с массивами</strong></a></div><ul><li><a href="https://www.php.net/manual/ru/function.array-change-key-case.php">array_change_key_case</a> — Меняет регистр всех ключей в массиве</li><li><a href="https://www.php.net/manual/ru/function.array-chunk.php">array_chunk</a> — Разбивает массив на части</li><li><a href="https://www.php.net/manual/ru/function.array-column.php">array_column</a> — Возвращает массив из значений одного столбца входного массива</li><li><a href="https://www.php.net/manual/ru/function.array-combine.php">array_combine</a> — Создаёт новый массив, используя один массив в качестве ключей, а другой для его значений</li><li><a href="https://www.php.net/manual/ru/function.array-count-values.php">array_count_values</a> — Подсчитывает количество всех значений массива</li><li><a href="https://www.php.net/manual/ru/function.array-diff-assoc.php">array_diff_assoc</a> — Вычисляет расхождение массивов с дополнительной проверкой индекса</li><li><a href="https://www.php.net/manual/ru/function.array-diff-key.php">array_diff_key</a> — Вычисляет расхождение массивов, сравнивая ключи</li><li><a href="https://www.php.net/manual/ru/function.array-diff-uassoc.php">array_diff_uassoc</a> — Вычисляет расхождение массивов с дополнительной проверкой индекса, осуществляемой при помощи callback-функции</li><li><a href="https://www.php.net/manual/ru/function.array-diff-ukey.php">array_diff_ukey</a> — Вычисляет расхождение массивов, используя callback-функцию для сравнения ключей</li><li><a href="https://www.php.net/manual/ru/function.array-diff.php">array_diff</a> — Вычислить расхождение массивов</li><li><a href="https://www.php.net/manual/ru/function.array-fill-keys.php">array_fill_keys</a> — Создаёт массив и заполняет его значениями с определёнными ключами</li><li><a href="https://www.php.net/manual/ru/function.array-fill.php">array_fill</a> — Заполняет массив значениями</li><li><a href="https://www.php.net/manual/ru/function.array-filter.php">array_filter</a> — Фильтрует элементы массива с помощью callback-функции</li><li><a href="https://www.php.net/manual/ru/function.array-flip.php">array_flip</a> — Меняет местами ключи с их значениями в массиве</li><li><a href="https://www.php.net/manual/ru/function.array-intersect-assoc.php">array_intersect_assoc</a> — Вычисляет схождение массивов с дополнительной проверкой индекса</li><li><a href="https://www.php.net/manual/ru/function.array-intersect-key.php">array_intersect_key</a> — Вычислить пересечение массивов, сравнивая ключи</li><li><a href="https://www.php.net/manual/ru/function.array-intersect-uassoc.php">array_intersect_uassoc</a> — Вычисляет схождение массивов с дополнительной проверкой индекса, осуществляемой при помощи callback-функции</li><li><a href="https://www.php.net/manual/ru/function.array-intersect-ukey.php">array_intersect_ukey</a> — Вычисляет схождение массивов, используя callback-функцию для сравнения ключей</li><li><a href="https://www.php.net/manual/ru/function.array-intersect.php">array_intersect</a> — Вычисляет схождение массивов</li><li><a href="https://www.php.net/manual/ru/function.array-is-list.php">array_is_list</a> — Проверяет, является ли данный array списком</li><li><a href="https://www.php.net/manual/ru/function.array-key-exists.php">array_key_exists</a> — Проверяет, присутствует ли в массиве указанный ключ или индекс</li><li><a href="https://www.php.net/manual/ru/function.array-key-first.php">array_key_first</a> — Получает первый ключ массива</li><li><a href="https://www.php.net/manual/ru/function.array-key-last.php">array_key_last</a> — Получает последний ключ массива</li><li><a href="https://www.php.net/manual/ru/function.array-keys.php">array_keys</a> — Возвращает все или некоторое подмножество ключей массива</li><li><a href="https://www.php.net/manual/ru/function.array-map.php">array_map</a> — Применяет callback-функцию ко всем элементам указанных массивов</li><li><a href="https://www.php.net/manual/ru/function.array-merge-recursive.php">array_merge_recursive</a> — Рекурсивное слияние одного или более массивов</li><li><a href="https://www.php.net/manual/ru/function.array-merge.php">array_merge</a> — Сливает один или большее количество массивов</li><li><a href="https://www.php.net/manual/ru/function.array-multisort.php">array_multisort</a> — Сортирует несколько массивов или многомерные массивы</li><li><a href="https://www.php.net/manual/ru/function.array-pad.php">array_pad</a> — Дополнить массив определённым значением до указанной длины</li><li><a href="https://www.php.net/manual/ru/function.array-pop.php">array_pop</a> — Извлекает последний элемент массива</li><li><a href="https://www.php.net/manual/ru/function.array-product.php">array_product</a> — Вычислить произведение значений массива</li><li><a href="https://www.php.net/manual/ru/function.array-push.php">array_push</a> — Добавляет один или несколько элементов в конец массива</li><li><a href="https://www.php.net/manual/ru/function.array-rand.php">array_rand</a> — Выбирает один или несколько случайных ключей из массива</li><li><a href="https://www.php.net/manual/ru/function.array-reduce.php">array_reduce</a> — Итеративно уменьшает массив к единственному значению, используя callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-replace-recursive.php">array_replace_recursive</a> — Рекурсивно заменяет элементы первого массива элементами переданных массивов</li><li><a href="https://www.php.net/manual/ru/function.array-replace.php">array_replace</a> — Заменяет элементы массива элементами других переданных массивов</li><li><a href="https://www.php.net/manual/ru/function.array-reverse.php">array_reverse</a> — Возвращает массив с элементами в обратном порядке</li><li><a href="https://www.php.net/manual/ru/function.array-search.php">array_search</a> — Осуществляет поиск данного значения в массиве и возвращает ключ первого найденного элемента в случае успешного выполнения</li><li><a href="https://www.php.net/manual/ru/function.array-shift.php">array_shift</a> — Извлекает первый элемент массива</li><li><a href="https://www.php.net/manual/ru/function.array-slice.php">array_slice</a> — Выбирает срез массива</li><li><a href="https://www.php.net/manual/ru/function.array-splice.php">array_splice</a> — Удаляет часть массива и заменяет её чем-нибудь ещё</li><li><a href="https://www.php.net/manual/ru/function.array-sum.php">array_sum</a> — Вычисляет сумму значений массива</li><li><a href="https://www.php.net/manual/ru/function.array-udiff-assoc.php">array_udiff_assoc</a> — Вычисляет расхождение в массивах с дополнительной проверкой индексов, используя для сравнения значений callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-udiff-uassoc.php">array_udiff_uassoc</a> — Вычисляет расхождение в массивах с дополнительной проверкой индексов, используя для сравнения значений и индексов callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-udiff.php">array_udiff</a> — Вычисляет расхождение массивов, используя для сравнения callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-uintersect-assoc.php">array_uintersect_assoc</a> — Вычисляет пересечение массивов с дополнительной проверкой индексов, используя для сравнения значений callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-uintersect-uassoc.php">array_uintersect_uassoc</a> — Вычисляет пересечение массивов с дополнительной проверкой индекса, используя для сравнения индексов и значений индивидуальные callback-функции</li><li><a href="https://www.php.net/manual/ru/function.array-uintersect.php">array_uintersect</a> — Вычисляет пересечение массивов, используя для сравнения значений callback-функцию</li><li><a href="https://www.php.net/manual/ru/function.array-unique.php">array_unique</a> — Убирает повторяющиеся значения из массива</li><li><a href="https://www.php.net/manual/ru/function.array-unshift.php">array_unshift</a> — Добавляет один или несколько элементов в начало массива</li><li><a href="https://www.php.net/manual/ru/function.array-values.php">array_values</a> — Выбирает все значения массива</li><li><a href="https://www.php.net/manual/ru/function.array-walk-recursive.php">array_walk_recursive</a> — Рекурсивно применяет пользовательскую функцию к каждому элементу массива</li><li><a href="https://www.php.net/manual/ru/function.array-walk.php">array_walk</a> — Применяет заданную пользователем функцию к каждому элементу массива</li><li><a href="https://www.php.net/manual/ru/function.array.php">array</a> — Создаёт массив</li><li><a href="https://www.php.net/manual/ru/function.arsort.php">arsort</a> — Сортирует массив в порядке убывания и поддерживает ассоциацию индексов</li><li><a href="https://www.php.net/manual/ru/function.asort.php">asort</a> — Сортирует массив в порядке возрастания и поддерживает ассоциацию индексов</li><li><a href="https://www.php.net/manual/ru/function.compact.php">compact</a> — Создаёт массив, содержащий названия переменных и их значения</li><li><a href="https://www.php.net/manual/ru/function.count.php">count</a> — Подсчитывает количество элементов массива или Countable объекте</li><li><a href="https://www.php.net/manual/ru/function.current.php">current</a> — Возвращает текущий элемент массива</li><li><a href="https://www.php.net/manual/ru/function.each.php">each</a> — Возвращает текущую пару ключ/значение из массива и смещает его указатель</li><li><a href="https://www.php.net/manual/ru/function.end.php">end</a> — Устанавливает внутренний указатель массива на его последний элемент</li><li><a href="https://www.php.net/manual/ru/function.extract.php">extract</a> — Импортирует переменные из массива в текущую таблицу символов</li><li><a href="https://www.php.net/manual/ru/function.in-array.php">in_array</a> — Проверяет, присутствует ли в массиве значение</li><li><a href="https://www.php.net/manual/ru/function.key-exists.php">key_exists</a> — Псевдоним array_key_exists</li><li><a href="https://www.php.net/manual/ru/function.key.php">key</a> — Выбирает ключ из массива</li><li><a href="https://www.php.net/manual/ru/function.krsort.php">krsort</a> — Сортирует массив по ключу в порядке убывания</li><li><a href="https://www.php.net/manual/ru/function.ksort.php">ksort</a> — Сортирует массив по ключу в порядке возрастания</li><li><a href="https://www.php.net/manual/ru/function.list.php">list</a> — Присваивает переменным из списка значения подобно массиву</li><li><a href="https://www.php.net/manual/ru/function.natcasesort.php">natcasesort</a> — Сортирует массив, используя алгоритм "natural order" без учёта регистра символов</li><li><a href="https://www.php.net/manual/ru/function.natsort.php">natsort</a> — Сортирует массив, используя алгоритм "natural order"</li><li><a href="https://www.php.net/manual/ru/function.next.php">next</a> — Перемещает указатель массива вперёд на один элемент</li><li><a href="https://www.php.net/manual/ru/function.pos.php">pos</a> — Псевдоним current</li><li><a href="https://www.php.net/manual/ru/function.prev.php">prev</a> — Передвигает внутренний указатель массива на одну позицию назад</li><li><a href="https://www.php.net/manual/ru/function.range.php">range</a> — Создаёт массив, содержащий диапазон элементов</li><li><a href="https://www.php.net/manual/ru/function.reset.php">reset</a> — Устанавливает внутренний указатель массива на его первый элемент</li><li><a href="https://www.php.net/manual/ru/function.rsort.php">rsort</a> — Сортирует массив в порядке убывания</li><li><a href="https://www.php.net/manual/ru/function.shuffle.php">shuffle</a> — Перемешивает массив</li><li><a href="https://www.php.net/manual/ru/function.sizeof.php">sizeof</a> — Псевдоним count</li><li><a href="https://www.php.net/manual/ru/function.sort.php">sort</a> — Сортирует массив по возрастанию</li><li><a href="https://www.php.net/manual/ru/function.uasort.php">uasort</a> — Сортирует массив, используя пользовательскую функцию для сравнения элементов с сохранением ключей</li><li><a href="https://www.php.net/manual/ru/function.uksort.php">uksort</a> — Сортирует массив по ключам, используя пользовательскую функцию для сравнения ключей</li><li><a href="https://www.php.net/manual/ru/function.usort.php">usort</a> — Сортирует массив по значениям используя пользовательскую функцию для сравнения элементов</li></ul>	t
110	Структурные паттерны	strukturnye-patterny	83	<div><strong>Структурные паттерны</strong> показывают различные способы построения связей между объектами.<br>Отвечают за построение удобных в поддержке иерархий классов.</div><ul><li>Адаптер</li><li>Мост</li><li>Компоновщик</li><li>Декоратор</li><li>Фасад</li><li>Легковес</li><li>Заместитель</li></ul><div><br></div><div><br></div>	t
112	Фабричный метод	fabrichnyi-metod	109	<div><strong>Фабричный метод</strong> — это порождающий паттерн проектирования, который определяет общий интерфейс для создания объектов в суперклассе, позволяя подклассам изменять тип создаваемых объектов.<br><strong><br>&nbsp;Структура</strong><br><br></div><ol><li><strong>Продукт</strong> определяет общий интерфейс объектов, которые может произвести создатель и его подклассы.</li><li><strong>Конкретные продукты</strong> содержат код различных продуктов. Продукты будут отличаться реализацией, но интерфейс у них будет общий.</li><li><strong>Создатель</strong> объявляет фабричный метод, который должен возвращать новые объекты продуктов. Важно, чтобы тип результата совпадал с общим интерфейсом продуктов.</li><li>Зачастую фабричный метод объявляют абстрактным, чтобы заставить все подклассы реализовать его по-своему. Но он может возвращать и некий стандартный продукт.</li><li>Несмотря на название, важно понимать, что создание продуктов <strong>не является</strong> единственной функцией создателя. Обычно он содержит и другой полезный код работы с продуктом. Аналогия: большая софтверная компания может иметь центр подготовки программистов, но основная задача компании — создавать программные продукты, а не готовить программистов.</li><li><strong>Конкретные создатели</strong> по-своему реализуют фабричный метод, производя те или иные конкретные продукты.</li><li>Фабричный метод не обязан всё время создавать новые объекты. Его можно переписать так, чтобы возвращать существующие объекты из какого-то хранилища или кэша.</li></ol><div><br><br></div>	t
109	Порождающие паттерны	porozhdaiushchie-patterny	83	<div><strong>Порождающие паттерны</strong> беспокоятся о гибком создании объектов без внесения в программу лишних зависимостей.<br>Отвечают за удобное и безопасное создание новых объектов или даже целых семейств объектов.</div><ul><li>Фабричный метод</li><li>Абстрактная фабрика</li><li>Строитель</li><li>Прототип</li><li>Одиночка</li></ul><div><br></div><div><br></div>	t
111	Поведенческие паттерны	povedencheskie-patterny	83	<div><strong>Поведенческие паттерны</strong> заботятся об эффективной коммуникации между объектами.</div><div>Решают задачи эффективного и безопасного взаимодействия между объектами программы.</div><ul><li>Цепочка обязанностей</li><li>Команда</li><li>Итератор</li><li>Посредник</li><li>Снимок</li><li>Наблюдатель</li><li>Состояние&nbsp;</li><li>Стратегия</li><li>Шаблонный метод</li><li>Посетитель</li></ul>	t
116	Одиночка	odinochka	109	<div><strong>Одиночка</strong> — это порождающий паттерн проектирования, который гарантирует, что у класса есть только один экземпляр, и предоставляет к нему глобальную точку доступа.<br><strong><br>Структура</strong><br><br></div><ol><li><strong>Одиночка</strong> определяет статический метод getInstance, который возвращает единственный экземпляр своего класса.<br><br></li><li>Конструктор одиночки должен быть скрыт от клиентов. Вызов метода getInstance должен стать единственным способом получить объект этого класса.</li></ol><div><br><strong><br>&nbsp;Преимущества и недостатки<br></strong><br></div><div>&nbsp;+ Гарантирует наличие единственного экземпляра класса.</div><div>&nbsp;+ Предоставляет к нему глобальную точку доступа.</div><div>+&nbsp; Реализует отложенную инициализацию объекта-одиночки.</div><div>- Нарушает <em>принцип единственной ответственности класса</em>.</div><div>&nbsp;- Маскирует плохой дизайн.</div><div>- Проблемы мультипоточности.</div><div>- Требует постоянного создания Mock-объектов при юнит-тестировании.</div><div><br></div><div><br></div>	t
83	ПАТТЕРНЫ	patterny	\N	<div>Паттерны отличаются по уровню сложности, детализации и охвата проектируемой системы. Проводя аналогию со строительством, вы можете повысить безопасность перекрёстка, поставив светофор, а можете заменить перекрёсток целой автомобильной развязкой с подземными переходами.<br><br></div><div>Самые низкоуровневые и простые паттерны — <em>идиомы</em>. Они не универсальны, поскольку применимы только в рамках одного языка программирования.<br><br></div><div>Самые универсальные — <em>архитектурные паттерны</em>, которые можно реализовать практически на любом языке. Они нужны для проектирования всей программы, а не отдельных её элементов.</div><div><br></div><ul><li><strong>Порождающие паттерны</strong> беспокоятся о гибком создании объектов без внесения в программу лишних зависимостей.</li><li><strong>Структурные паттерны</strong> показывают различные способы построения связей между объектами.</li><li><strong>Поведенческие паттерны</strong> заботятся об эффективной коммуникации между объектами.</li></ul><div><br></div>	t
115	Прототип	prototip	109	<div><strong>Прототип</strong> — это порождающий паттерн проектирования, который позволяет копировать объекты, не вдаваясь в подробности их реализации.<br><strong><br>&nbsp;Структура<br></strong><br></div><div><strong>Базовая реализация</strong><br><br></div><ol><li><strong>Интерфейс прототипов</strong> описывает операции клонирования. В большинстве случаев — это единственный метод clone.</li><li><strong>Конкретный прототип</strong> реализует операцию клонирования самого себя. Помимо банального копирования значений всех полей, здесь могут быть спрятаны различные сложности, о которых не нужно знать клиенту. Например, клонирование связанных объектов, распутывание рекурсивных зависимостей и прочее.</li><li><strong>Клиент</strong> создаёт копию объекта, обращаясь к нему через общий интерфейс прототипов.</li></ol><div><strong><br>Реализация с общим хранилищем прототипов</strong><br><br></div><ol><li><strong>Хранилище прототипов</strong> облегчает доступ к часто используемым прототипам, храня набор предварительно созданных эталонных, готовых к копированию объектов. Простейшее хранилище может быть построено с помощью хеш-таблицы вида имя-прототипа → прототип. Но для удобства поиска прототипы можно маркировать и другими критериями, а не только условным именем.</li></ol>	t
\.


--
-- Name: menu_id_seq; Type: SEQUENCE SET; Schema: public; Owner: user
--

SELECT pg_catalog.setval('public.menu_id_seq', 116, true);


--
-- Name: doctrine_migration_versions doctrine_migration_versions_pkey; Type: CONSTRAINT; Schema: public; Owner: user
--

ALTER TABLE ONLY public.doctrine_migration_versions
    ADD CONSTRAINT doctrine_migration_versions_pkey PRIMARY KEY (version);


--
-- Name: menu menu_pkey; Type: CONSTRAINT; Schema: public; Owner: user
--

ALTER TABLE ONLY public.menu
    ADD CONSTRAINT menu_pkey PRIMARY KEY (id);


--
-- Name: idx_7d053a93727aca70; Type: INDEX; Schema: public; Owner: user
--

CREATE INDEX idx_7d053a93727aca70 ON public.menu USING btree (parent_id);


--
-- Name: menu fk_7d053a93727aca70; Type: FK CONSTRAINT; Schema: public; Owner: user
--

ALTER TABLE ONLY public.menu
    ADD CONSTRAINT fk_7d053a93727aca70 FOREIGN KEY (parent_id) REFERENCES public.menu(id);


--
-- PostgreSQL database dump complete
--

